/*
 * tests.cpp
 *
 *  Created on: Oct 14, 2008
 *  Revised Oct 2009
 *      Author: bloch
 */

#include <iostream>
using std::cout;
using std::endl;

#include "EmptyIntList.h"
#include "NonEmptyIntList.h"

NonEmptyIntList *force(IntList *blah)
{
	return dynamic_cast<NonEmptyIntList *>(blah);
}

int main () {
	IntList *ex0 = new EmptyIntList();
	IntList *ex1 = new NonEmptyIntList(3, ex0);
	IntList *ex2 = new NonEmptyIntList(-7, ex1);

	cout << "ex0->isEmpty(): " << ex0->isEmpty() << " should be true" << endl;
	cout << "ex1->isEmpty(): " << ex1->isEmpty() << " should be false" << endl;
	cout << "ex2->isEmpty(): " << ex2->isEmpty() << " should be false" << endl;

	cout << "ex1->getFirst(): " << dynamic_cast<NonEmptyIntList *>(ex1)->getFirst() << " should be 3 " << endl;

	// That's a pain.  Let's put that cast into a function:
	NonEmptyIntList *ex1again = force(ex1);
	NonEmptyIntList *ex2again = force(ex2);

	cout << "ex1again->getFirst(): " << ex1again->getFirst() << " should be 3" << endl;
	cout << "ex2again->getFirst(): " << ex2again->getFirst() << " should be -7" << endl;
	cout << "ex2again->getRest()->getFirst(): " <<
		force(ex2again->getRest())->getFirst() << " should be 3" << endl;
	cout << "ex0->length(): " << ex0->length() << " should be 0" << endl;
	cout << "ex1->length(): " << ex1->length() << " should be 1" << endl;
	cout << "ex2->length(): " << ex2->length() << " should be 2" << endl;

	cout << "ex0: " << (*ex0) << " should be []" << endl;
	cout << "ex1: " << (*ex1) << " should be [3]" << endl;
	cout << "ex2: " << (*ex2) << " should be [-7, 3]" << endl;

	IntList *bigex =
		new NonEmptyIntList (12,
				new NonEmptyIntList (-2,
						new NonEmptyIntList (-73,
								new NonEmptyIntList (0,
										new NonEmptyIntList (3,
												new EmptyIntList())))));
	cout << "bigex->getRest()->getRest()->getFirst(): " <<
		force(force(force(bigex)->getRest())->getRest())->getFirst() <<
		" should be -73" << endl;
	cout << "bigex: " << *bigex << " should be [12, -2, -73, 0, 3]" << endl;

	cout << "bigex->length(): " << bigex->length() << " should be 5" << endl;

	cout << "ex1again->getRest()->getFirst(): " <<
		force(ex1again->getRest())->getFirst() <<
		" should throw an exception because ex1again->getRest() is empty" << endl;
	cout << "We shouldn't get here at all!" << endl;
	return 0;
}
